// Procedures for ContentSaver Firefox extension
// macropool GmbH, 2005
// All rights reserved
// Developer: Martin Koppmann


var gCSWrapper = null;
var gTabBrowser = null;
var gBrowsers = null;
var gWebNav = null;


window.removeEventListener("load", initContentSaver, true);
window.addEventListener("load",    initContentSaver, true);

CS = {
	StartCSApp : function()
	{
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
		var csWrapper = Components.classes["@macropool.com/ContentSaver;1"].createInstance();
		csWrapper = csWrapper.QueryInterface(Components.interfaces.nsIContentSaver);
		csWrapper.StartCSApp();	
	},
};


function prepareSaving()
{
	gTabBrowser = document.getElementById("content");
	gBrowsers =  gTabBrowser.browsers;
	var msg = "Browser Count = ";
	msg += gBrowsers.length + "\n";
	dump (msg);
	
	var browser = null;
	browser = gTabBrowser.selectedBrowser
	
	var url = browser.currentURI.spec;
	if ((!url) || (url == '') || (url == 'about:blank')) {
		// blank
		return;
	}
	
	// If control gets here, we have a non-Null browser
	reportUrl (url);
	gWebNav = browser.webNavigation;
}

function SaveSelection()
{
	if (gCSWrapper) return;
	prepareSaving();
	// get focused Window
	var myWindow = document.commandDispatcher.focusedWindow;
	if ( !myWindow || myWindow == window ) myWindow = window._content;	
	var doc = myWindow.document;
	netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	var csWrapper = Components.classes["@macropool.com/ContentSaver;1"].createInstance();
	csWrapper = csWrapper.QueryInterface(Components.interfaces.nsIContentSaver);
	csWrapper.Overlay = document;
	csWrapper.URL = doc.location.href;
	
	var sel = myWindow.getSelection();
	var title = sel.toString();
	
	var index = title.indexOf("\n");
	if (index > 0)
		title = title.substring(0,index);
	else
		title = title.substring(0,80);
		
	csWrapper.Title = title;
	csWrapper.DocType = 101;
	goDoCommand('cmd_copy');
	csWrapper.GetClipboardHTML();
	gCSWrapper = csWrapper;
	csWrapper.Save();
}

function SaveSelectionAs()
{
	prepareSaving();
	// get focused Window
	var myWindow = document.commandDispatcher.focusedWindow;
	if ( !myWindow || myWindow == window ) myWindow = window._content;	
	var doc = myWindow.document;
	netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	var csWrapper = Components.classes["@macropool.com/ContentSaver;1"].createInstance();
	csWrapper = csWrapper.QueryInterface(Components.interfaces.nsIContentSaver);
	csWrapper.Overlay = document;
	goDoCommand('cmd_copy');
	csWrapper.GetClipboardHTML();
	csWrapper.URL = doc.location.href;
	
	var sel = myWindow.getSelection();
	var title = sel.toString();
	
	var index = title.indexOf("\n");
	if (index > 0)
		title = title.substring(0,index);
	else
		title = title.substring(0,80);

	csWrapper.Title = title;
	csWrapper.DocType = 101;
	gCSWrapper = csWrapper;	
	csWrapper.SaveAs(4);
}

function CancelSaving()
{
	netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	gCSWrapper.Interrupt();
}

function StartCSSaver ()
{
	prepareSaving();	
	var doc = gWebNav.document;
	
	netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	var csWrapper = Components.classes["@macropool.com/ContentSaver;1"].createInstance();
	csWrapper = csWrapper.QueryInterface(Components.interfaces.nsIContentSaver);

	var sURL = doc.location.href;
	csWrapper.StartCSSaver(sURL);
}

function SaveOneClick()
{
	prepareSaving();	
	var doc = gWebNav.document;
	
	var Frames = doc.getElementsByTagName('FRAME');
	var FrameCount = Frames.length
	if (FrameCount > 0) {
		var obj = new Object ( );
		obj.result = "";	
		window.openDialog("chrome://contentsaver/content/frames.xul", 'foo_main',
		                  "chrome,dialog=yes,close,modal=yes,centerscreen", obj);
		if (obj.result=='No') return;
	}		
	
	netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	var csWrapper = Components.classes["@macropool.com/ContentSaver;1"].createInstance();
	csWrapper = csWrapper.QueryInterface(Components.interfaces.nsIContentSaver);
	csWrapper.Document = doc;
	csWrapper.Overlay = document;
	csWrapper.URL = doc.location.href;
	if (doc.title) {csWrapper.Title = doc.title;}
	csWrapper.DocType=0;
	netscape.security.PrivilegeManager.enablePrivilege("BrowserWrite BrowserAccess");	
	gCSWrapper = csWrapper;	
	csWrapper.Save();
}

function SaveWebPageAs()
{
	prepareSaving();
	var doc = gWebNav.document;
	
	var Frames = doc.getElementsByTagName('FRAME');
	var FrameCount = Frames.length
	if (FrameCount > 0) {
		var obj = new Object ( );
		obj.result = "";	
		window.openDialog("chrome://contentsaver/content/frames.xul", 'foo_main',
		                  "chrome,dialog=yes,close,modal=yes,centerscreen", obj);
		if (obj.result=='No') return;
	}		
	
	netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	var csWrapper = Components.classes["@macropool.com/ContentSaver;1"].createInstance();
	csWrapper = csWrapper.QueryInterface(Components.interfaces.nsIContentSaver);
	csWrapper.Overlay = document;
	csWrapper.Document = doc;
	csWrapper.URL = doc.location.href;
	csWrapper.Title = doc.title;
	csWrapper.DocType=0;
	gCSWrapper = csWrapper;	
	csWrapper.SaveAs(1);
}

function SaveScreenClipping()
{
	prepareSaving();	
	netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	var csWrapper = Components.classes["@macropool.com/ContentSaver;1"].createInstance();
	csWrapper = csWrapper.QueryInterface(Components.interfaces.nsIContentSaver);
	csWrapper.Overlay = document;
	csWrapper.SaveScreenClipping();	
}

function SaveAddressAs()
{
	prepareSaving();
	var doc = gWebNav.document;
	netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	var csWrapper = Components.classes["@macropool.com/ContentSaver;1"].createInstance();
	csWrapper = csWrapper.QueryInterface(Components.interfaces.nsIContentSaver);
	csWrapper.Overlay = document;
	csWrapper.URL = doc.location.href;
	csWrapper.Title = doc.title;
	csWrapper.DocType=300;
	csWrapper.SaveAs(32);
}

function SaveCurrentFrame() {
	prepareSaving();
	// get focused Window
	var myWindow = document.commandDispatcher.focusedWindow;
	if ( !myWindow || myWindow == window ) myWindow = window._content;	
	var doc = myWindow.document;
	netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	var csWrapper = Components.classes["@macropool.com/ContentSaver;1"].createInstance();
	csWrapper = csWrapper.QueryInterface(Components.interfaces.nsIContentSaver);
	csWrapper.Document = doc;
	csWrapper.Overlay = document;
	csWrapper.URL = doc.location.href;
	csWrapper.Title = doc.title;
	csWrapper.DocType=0;
	netscape.security.PrivilegeManager.enablePrivilege("BrowserWrite BrowserAccess");
	gCSWrapper = csWrapper;		
	csWrapper.Save();	
}

function SaveCurrentFrameAs() {
	prepareSaving();
	// get focused Window
	var myWindow = document.commandDispatcher.focusedWindow;
	if ( !myWindow || myWindow == window ) myWindow = window._content;	
	var doc = myWindow.document;
	netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	var csWrapper = Components.classes["@macropool.com/ContentSaver;1"].createInstance();
	csWrapper = csWrapper.QueryInterface(Components.interfaces.nsIContentSaver);
	csWrapper.Document = doc;
	csWrapper.Overlay = document;
	csWrapper.URL = doc.location.href;
	csWrapper.Title = doc.title;
	csWrapper.DocType=0;
	netscape.security.PrivilegeManager.enablePrivilege("BrowserWrite BrowserAccess");		
	gCSWrapper = csWrapper;		
	csWrapper.SaveAs(8);	
}

function SaveTarget() {
	prepareSaving();

	var linkURL = gContextMenu.getLinkURL();
	if ( !linkURL ) return;
    // document.popupNode.ownerDocument.location.href
	netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	var csWrapper = Components.classes["@macropool.com/ContentSaver;1"].createInstance();
	csWrapper = csWrapper.QueryInterface(Components.interfaces.nsIContentSaver);
	csWrapper.Overlay = document;
	csWrapper.URL = linkURL;
	//csWrapper.Title = doc.title;
	csWrapper.DocType=0;	
	gCSWrapper = csWrapper;		
	csWrapper.Save();	
}

function SaveTargetAs() {
	prepareSaving();

	var linkURL = gContextMenu.getLinkURL();
	if ( !linkURL ) return;
    // document.popupNode.ownerDocument.location.href
	netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	var csWrapper = Components.classes["@macropool.com/ContentSaver;1"].createInstance();
	csWrapper = csWrapper.QueryInterface(Components.interfaces.nsIContentSaver);
	csWrapper.Overlay = document;
	csWrapper.URL = linkURL;
	csWrapper.Title = '';
	csWrapper.DocType=0;
	gCSWrapper = csWrapper;
	csWrapper.SaveAs(16);	
}

function SaveAddressContext() {
	prepareSaving();

	var linkURL = gContextMenu.getLinkURL();
    // document.popupNode.ownerDocument.location.href
	netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
	var csWrapper = Components.classes["@macropool.com/ContentSaver;1"].createInstance();
	csWrapper = csWrapper.QueryInterface(Components.interfaces.nsIContentSaver);
	csWrapper.Overlay = document;
	csWrapper.URL = linkURL;
	csWrapper.Title = '';
	csWrapper.DocType=300;
	csWrapper.SaveAs(32);	
}

function SaveImage() {

	var imgElem = document.popupNode;	
	
	if (imgElem) {
		prepareSaving();
		 // document.popupNode.ownerDocument.location.href
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
		var csWrapper = Components.classes["@macropool.com/ContentSaver;1"].createInstance();
		csWrapper = csWrapper.QueryInterface(Components.interfaces.nsIContentSaver);
		csWrapper.Overlay = document;
		csWrapper.URL = imgElem.src;
		if (imgElem.alt)  
			csWrapper.Title = imgElem.alt;
		else
			csWrapper.Title = '';
		csWrapper.DocType=110;	
		gCSWrapper = csWrapper;			
		csWrapper.Save();			
	}
}

function SaveImageAs() {
	
	var imgElem = document.popupNode;	

	if (imgElem) {
		prepareSaving();
	    // document.popupNode.ownerDocument.location.href
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
		var csWrapper = Components.classes["@macropool.com/ContentSaver;1"].createInstance();
		csWrapper = csWrapper.QueryInterface(Components.interfaces.nsIContentSaver);
			csWrapper.Overlay = document;
		csWrapper.URL = imgElem.src;
		if (imgElem.alt)  
			csWrapper.Title = imgElem.alt;
		else
			csWrapper.Title = '';
		csWrapper.DocType=110;	
		gCSWrapper = csWrapper;		
		csWrapper.SaveAs(2);			
	}
		

}

function reportUrl (url)
{
     var msg = "ContentSaver handles the following URL:\n";
     msg += url + "\n";
     dump (msg);
}

function initContentSaver()
{
	// window.removeEventListener("load",onloadlistener,true);
	// doc that has loaded can be retrieved via event.originalTarget
  // document.getElementById("appcontent").addEventListener("load", onloadprocessing, true);
	/*
	var tb = document.getElementById("content");
	if (tb) {
		tb.addEventListener("load", onloadprocessing, true);
	}
	*/


	// Kontextmen
	var menu = document.getElementById("contentAreaContextMenu");
	menu.removeEventListener("popupshowing", ShowHideContextMenu, true);
	menu.addEventListener("popupshowing",    ShowHideContextMenu, true);
}

function onloadprocessing(event) {
	var page = event.originalTarget; //defaultView
	alert(page);
}

function ShowHideContextMenu()
{
	document.getElementById("cmdSaveSelection").hidden = true;
	document.getElementById("cmdSaveSelectionAs").hidden = true;
	document.getElementById("cmdSaveFrame").hidden = true;
	document.getElementById("cmdSaveFrameAs").hidden = true;
	document.getElementById("cmdSavePicture").hidden =  true;
	document.getElementById("cmdSavePictureAs").hidden = true;
	document.getElementById("cmdSaveTarget").hidden = true;
	document.getElementById("cmdSaveTargetAs").hidden = true;
	document.getElementById("cmdSaveAddressAs").hidden = true;

	if (gContextMenu.onImage == true) {

		document.getElementById("cmdSavePicture").hidden = false;
		document.getElementById("cmdSavePictureAs").hidden = false;
		
		if ((gContextMenu.onLink == true) && (gContextMenu.onMailtoLink == false)) {
			document.getElementById("cmdSaveAddressAs").hidden = false;
			document.getElementById("cmdSaveTarget").hidden = false;
			document.getElementById("cmdSaveTargetAs").hidden = false;
		}
	} else {
		if (gContextMenu.isTextSelected == true) {
			document.getElementById("cmdSaveSelection").hidden = false;
			document.getElementById("cmdSaveSelectionAs").hidden = false;
		} else {
			if ((gContextMenu.onLink == true) && (gContextMenu.onMailtoLink == false)) {
				document.getElementById("cmdSaveTarget").hidden = false;
				document.getElementById("cmdSaveTargetAs").hidden = false;
				document.getElementById("cmdSaveAddressAs").hidden = false;			
			} else {
				document.getElementById("cmdSaveFrame").hidden = false;
				document.getElementById("cmdSaveFrameAs").hidden = false;			
			}
		}
	}
}

function ToogleEditMode()
{
	// get focused Window
	var myWindow = document.commandDispatcher.focusedWindow;
	if ( !myWindow || myWindow == window ) myWindow = window._content;	
	var doc = myWindow.document;	
	doc.body.contentEditable = 'true'; 
	doc.designMode='on';
}

function DocumentComplete( Argument )
{
	gCSWrapper = null;
}

function CollapseCSBar()
{
	var csbar =	document.getElementById("contentsaver-bar")
	if (csbar)
		csbar.collapsed=true
	else
		alert("no csbar found");
}


/*
onabort
onblur
onerror
onfocus
onchange
onclick
oncontextmenu
ondestroy
onload
onpaint
onkeydown
onkeypress
onkeyup
onunload
onmousemove
onmouseout
onmouseover
onmouseup
onmousedown
onrest
onresize
onscroll
onselect
onsubmit
*/